/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package gpttw.func;

import ec.*;
import ec.gp.*;
import ec.util.*;


public class Nop extends GPNode {

    public String toString() {
        return "Nop";
    }

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final GPIndividual typicalIndividual,
                                 final Parameter individualBase) {
        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (children.length != 0)
            state.output.error("Incorrect number of children for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final GPData input, final ADFStack stack,
                     final GPIndividual individual, final Problem problem) {

        // Just do nothing, as the name implies
    }

}



