/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

package npttw;

import java.io.*;
import java.net.*;

import ec.*;
import evision.ec.np.*;

import ToyTank.*;


public class NPTTWIndividualBrain extends NPTTW {
    private NPIndividual individual;

    public NPTTWIndividualBrain() {
        super();

        individual = readNPIndividual();
    }

    public NPIndividual readNPIndividual() {
        String filename =
            System.getProperty(NPTTWStatistics.P_SERIALIZATION,
                               NPTTWStatistics.DEFAULT_FILENAME);

        NPIndividual individual = null;

        try {
            InputStream in = ClassLoader.getSystemResourceAsStream(filename);
            ObjectInputStream ins = new ObjectInputStream(in);

            individual = (NPIndividual) ins.readObject();

            ins.close();
            in.close();

            individual.graphs[0].resetGraph(null, 0);
        }
        catch (Exception e) {
            e.printStackTrace();

            throw new RuntimeException("Error while reading individual " + e);
        }

        return individual;
    }

    public void action(TankAction t) {

        // Reset action
        turn = 0f;
        move = 0f;
        aim = 0f;
        fire = false;

        // Evaluate individual
        individual.graphs[0].eval(null, 0, null, null, individual, this);

        t.turn(turn);
        t.move(move);
        t.aim(aim);

        if (fire)
            t.fire();
    }


    public void sensor(TankSensor t) {
        tankSensor = t;
    }

    public void restart() {

        individual.graphs[0].resetGraph(null, 0);
    }

    public void stop() {

        // Ok
    }

    public void close() {

        // Ok
    }

    public void close(int finalGap) {

        // Ok
    }


}

