/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

package npttw.func;

import ec.*;
import ec.util.*;

import evision.ec.np.*;

import npttw.*;


public abstract class BasicAction extends BasicNode implements TankConstants {

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final NPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (links.length != 1)
            state.output.error("Incorrect number of links for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final NPData input, final ADFContext context,
                     final NPMemory newMemory, final NPIndividual individual,
                     final Problem problem) {

        if (((NPTTWMemory) links[0].memory).value) {

            // Perform the action
            ((NPTTWMemory) newMemory).value = action((NPTTW) problem);
        }
        else {
            ((NPTTWMemory) newMemory).value = false;
        }
    }

    protected abstract boolean action(NPTTW npttw);
}

