/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

package npttw.func;

import ec.*;
import ec.util.*;

import evision.ec.np.*;

import npttw.*;


public class IfTE extends BasicNode {

    public String toString() {
        return "IfTE";
    }

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final NPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (links.length != 3)
            state.output.error("Incorrect number of links for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final NPData input, final ADFContext context,
                     final NPMemory newMemory, final NPIndividual individual,
                     final Problem problem) {

        if (((NPTTWMemory) links[0].memory).value) {

            ((NPTTWMemory) newMemory).value =
                ((NPTTWMemory) links[1].memory).value;
        }
        else {

            ((NPTTWMemory) newMemory).value =
                ((NPTTWMemory) links[2].memory).value;
        }
    }

}

