/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * Brain for a tank
 *
 * A standard interface for any type of control system.
 *
 * Author  Matthew Caryl
 * Created 13.11.96
 *
 * Although under copywrite to the author (Matthew Caryl) this code can
 * be copied and modified for non-commercial
 * purposes as long as any derivatives contain this condition.
 */

package ToyTank;

import ADT.Random;

public interface Brain {

    public void sensor(TankSensor t);
    public void action(TankAction t);
    public void restart();
    public void stop();
    public void close();
    public void close(int finalGap);
}

