/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.np;

import ec.*;
import ec.util.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public abstract class NPProblem implements Problem {
    static final long serialVersionUID = -6728380188077002861L;

    public final static String P_NPPROBLEM = "problem";
    public final static String P_DATA = "data";

    /**
     * The NPProblems' NPData
     */
    public NPData data;

    /**
     * NPProblem defines a default base so your subclass doesn't
     * absolutely have to.
     */
    public Parameter defaultBase() {
        return NPDefaults.base().push(P_NPPROBLEM);
    }

    public void setup(final EvolutionState state, final Parameter base) {
        // Do nothing by default
    }

    public Object protoClone() throws CloneNotSupportedException {
        NPProblem prob = (NPProblem) (super.clone());

        // ADF Stack deep clone will go here

        return prob;
    }

    public final Object protoCloneSimple() {
        try {
            return protoClone();
        }
        catch (CloneNotSupportedException e) {
            throw new InternalError();
        }   // never happens
     }

    public void describe(final Individual[] ind, final EvolutionState state,
                         final int threadnum, final int log,
                         final int verbosity) {

        // default version does nothing
        return;
    }

}


