/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.util;

import java.io.*;
import java.util.Vector;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class DOTWriter extends IndividualWriter {

    // Just re-assert constructors

    public DOTWriter(Writer out) {
        super(out);
    }

    public DOTWriter(Writer out, boolean autoFlush) {
        super(out, autoFlush);
    }

    public DOTWriter(OutputStream out) {
        super(out);
    }

    public DOTWriter(OutputStream out, boolean autoFlush) {
        super(out, autoFlush);
    }

    // Protected
    protected void writeGraph(Vector nodes, Vector links) {
        println("digraph G {");
        println("rankdir=LR;");

        // First go, nodes
        Node node = null;

        for (int i = 0; i < nodes.size(); i++) {
            node = (Node) nodes.elementAt(i);

            println("n" + node.id +
            " [label=\"" + node.label + "\"];");
        }

        // Second go, links
        Link link = null;

        for (int i = 0; i < links.size(); i++) {
            link = (Link) links.elementAt(i);

            print("n" + link.from + " -> n" + link.to);
            println(" [label=\"" + link.label + "\"];");
        }

        println("}");
    }

}

