/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.util;

import java.io.*;
import java.util.Vector;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class GMLWriter extends IndividualWriter {

    // Just re-assert constructors

    public GMLWriter(Writer out) {
        super(out);
    }

    public GMLWriter(Writer out, boolean autoFlush) {
        super(out, autoFlush);
    }

    public GMLWriter(OutputStream out) {
        super(out);
    }

    public GMLWriter(OutputStream out, boolean autoFlush) {
        super(out, autoFlush);
    }

    // Protected
    protected void writeGraph(Vector nodes, Vector links) {
        println("graph[");
        println("directed 1");

        // First go, nodes
        Node node = null;

        for (int i = 0; i < nodes.size(); i++) {
            node = (Node) nodes.elementAt(i);

            println("node[");
            println("id " + node.id);
            println("label \"" + node.label + "\"");
            println("]");
        }

        // Second go, links
        Link link = null;

        for (int i = 0; i < links.size(); i++) {
            link = (Link) links.elementAt(i);

            println("edge[");
            println("source " + link.from);
            println("target " + link.to);
            println("label \"" + link.label + "\"");
            println("]");
        }

        println("]");
    }

}

