package evision.ec.util;

import java.io.*;

import ec.gp.*;
import evision.ec.np.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class VerifyNPIndividual {

    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage: VerifyNPIndividual <filename>");

            return;
        }

        NPIndividual individual;

        try {
            InputStream in = new FileInputStream(args[0]);
            ObjectInputStream ins = new ObjectInputStream(in);

            individual = (NPIndividual) ins.readObject();

            ins.close();
            in.close();
        }
        catch (Exception e) {
            e.printStackTrace();

            throw new RuntimeException("Error while reading individual " + e);
        }

        individual.verifyIndividual(false);

        System.out.println("OK");
    }
}