/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

package gpttw;

import java.io.*;
import java.net.*;

import ec.*;
import ec.gp.*;

import ToyTank.*;


public class GPTTWIndividualBrain extends GPTTW {
    private GPIndividual individual;

    public GPTTWIndividualBrain() {
        super();

        individual = readGPIndividual();
    }

    public GPIndividual readGPIndividual() {
        String filename =
            System.getProperty(GPTTWStatistics.P_SERIALIZATION,
                               GPTTWStatistics.DEFAULT_FILENAME);
                               
        GPIndividual individual = null;

        try {
            InputStream in = ClassLoader.getSystemResourceAsStream(filename);
            ObjectInputStream ins = new ObjectInputStream(in);

            individual = (GPIndividual) ins.readObject();

            ins.close();
            in.close();
        }
        catch (Exception e) {
            e.printStackTrace();

            throw new RuntimeException("Error while reading individual " + e);
        }

        return individual;
    }

    public void action(TankAction t) {

        // Reset action
        turn = 0f;
        move = 0f;
        aim = 0f;
        fire = false;

        // Evaluate individual
        individual.trees[0].child.eval(null, 0, null, null, individual, this);

        t.turn(turn);
        t.move(move);
        t.aim(aim);

        if (fire)
            t.fire();
    }


    public void sensor(TankSensor t) {
        tankSensor = t;
    }

    public void restart() {

        // Ok
    }

    public void stop() {

        // Ok
    }

    public void close() {

        // Ok
    }

    public void close(int finalGap) {

        // Ok
    }


}

