
/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */

package gpttw.func;

import ec.*;
import ec.gp.*;
import ec.util.*;

import gpttw.*;


public abstract class BasicAction extends GPNode implements TankConstants {

    public abstract String toString();

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final GPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (children.length != 0)
            state.output.error("Incorrect number of children for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final GPData input, final ADFStack stack,
                     final GPIndividual individual, final Problem problem) {

        action((GPTTW) problem);


    }

    protected abstract void action(GPTTW gpttw);
}
