
;; Tank example

(deffunction connect()
  (bind ?tank (new jessttw.TTWConnectionHandler "localhost" "2001" "jessttw" "255" "255" "0")))


(defrule move-by-default
    (SENSOR)
    =>
    (store MOVE (+ (fetch MOVE) 1.0)))

(defrule see-it-shoot-it
    (TankCenterTurret)
    =>
    (store FIRE 1))

(defrule avoid-obstacle-in-front
   (ObstacleFrontSide)
    =>
    (store MOVE (- (fetch MOVE) 2.0))
    (store TURN 2.0))

(defrule avoid-obstacle-on-the-left
    (ObstacleLeftSide)
    =>
    (store MOVE (- (fetch MOVE) 1.0))
    (store TURN 1.0))

(defrule avoid-obstacle-on-the-right
    (ObstacleRightSide)
    =>
    (store MOVE (- (fetch MOVE) 1.0))
    (store TURN -1.0))

(defrule aim-right
    (not (TankCenterTurret))
    (TankRightTurret)
    =>
    (store AIM 1.0))

(defrule aim-left
    (not (TankCenterTurret))
    (TankLeftTurret)
    =>
    (store AIM -1.0))


(defrule avoid-tank-on-the-left
    (TankLeftSide)
    =>
    (store TURN 1.0))

(defrule avoid-tank-on-the-right
    (TankRightSide)
    =>
    (store TURN -1.0))