/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

package npttw.func;

import ec.*;
import ec.util.*;

import evision.ec.np.*;

import npttw.*;


public abstract class BasicBinaryOperator extends BasicNode {

    public void checkConstraints(final EvolutionState state, final int tree,
                                 final NPIndividual typicalIndividual,
                                 final Parameter individualBase) {

        super.checkConstraints(state, tree, typicalIndividual,
                               individualBase);

        if (links.length != 2)
            state.output.error("Incorrect number of links for node "
                               + toStringForError() + " at "
                               + individualBase);
    }

    public void eval(final EvolutionState state, final int thread,
                     final NPData input, final ADFContext context,
                     final NPMemory newMemory, final NPIndividual individual,
                     final Problem problem) {

        ((NPTTWMemory) newMemory).value = condition((NPTTW) problem);
    }

    protected abstract boolean condition(NPTTW npttw);
}

