/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package npttw.func;

import npttw.NPTTW;
import ToyTank.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class Shot extends BasicSensor {

    int previousEnergy = 0;

    public String toString() {
        return "Shot";
    }

    protected boolean condition(NPTTW npttw) {

        TankSensor s = npttw.getTankSensor();

        int energy = s.energy();

        // A shell is assumed to cost 1
        if (previousEnergy > (energy + 2)) {

            previousEnergy = energy;
            return true;
        }
        else {
            previousEnergy = energy;
            return false;
        }
    }

}

