/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

/*
 * AI Tank Sensors
 *
 * An interface to the tank purely for information gathering,
 * no movements may be made.
 *
 * Author  Matthew Caryl
 * Created 14.11.96
 *
 * Although under copywrite to the author (Matthew Caryl)
 * this code can be copied and modified for non-commercial
 * purposes as long as any derivatives contain this condition.
 */

package ToyTank;

public interface TankSensor {
    public int energy();
    public boolean turretRadar(float start, float finish, float range);
    public boolean tankRadar(float start, float finish, float range);
    public boolean collisionSensor(float start, float finish);
    public boolean obstacleSensor(float start, float finish, float range);
}

