/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package ec.app.lawnmower;

import java.io.File;

import ec.*;
import ec.gp.*;
import ec.gp.koza.*;
import ec.util.*;

import evision.ec.util.*;

/*
 * LawnmowerStatistics.java
 *
 * Created: Fri Nov  5 16:03:44 1999
 * By: Sean Luke
 */

/**
 * @author Sean Luke
 * @version 1.0
 */

public class LawnmowerStatistics extends KozaStatistics {
    int generation = 0;

    public void postEvaluationStatistics(final EvolutionState state) {

        // print out the other statistics
        super.postEvaluationStatistics(state);

        ++generation;

        try {
            GraphViewer.saveGMLFile(GraphBuilder.fromGPTree(((GPIndividual) best_of_run).trees[0]),
                                    new File("generation" + generation
                                             + ".gml"));
        }
        catch (Exception e) {}

    }



    public void finalStatistics(final EvolutionState state,
                                final int result) {

        // print out the other statistics
        super.finalStatistics(state, result);

        // we have only one population, so this is kosher
        ((Problem) (state.evaluator.p_problem.protoCloneSimple())).describe(new Individual[] {
            best_of_run
        }, state, 0, statisticslog, Output.V_NO_GENERAL);
    }

}

