/*--- formatted by Jindent 2.1, (www.c-lab.de/~jindent) ---*/

package evision.ec.np;

import ec.*;
import ec.util.Parameter;

/*
 * A static class that returns the base for "default values" which NP-style
 * operators use, rather than making the user specify them all on a per-
 * species basis.
 *
 * Created: Tue Oct 12 17:44:47 1999
 * By: Sean Luke
 */

public final class NPDefaults implements DefaultsForm {
    public static final String P_NP = "np";

    /**
     * Returns the default base.
     */
    public static final Parameter base() {
        return new Parameter(P_NP);
    }

}

